unit LDN184u1;

(*NEED TO WRITE...

buSaveAlteredClick...

AND THEN DO GENERAL CLEAN-Up, then "done" and WRITE UP AS
LAZARUS TUT!! STRESS THAT IT "strains" things, AND HAS weaknesses....
IT IS ONLY MEANT TO SHOW HOW
TFileStream can be used.

It is a step towards something more clever... something that allows a
file that would be too big for memo to be processes.

Would allow file with non-pinting chars to be processed...

Open source, "connect" to a stream
 Open dest, "connect" to a stream
   Repeat-
      Fetch 1 (or a few)
      Process, and send to dest
   Until source empty
Free streams.     *)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

const ver='2 Aug 2011';
//Started 2 Aug 11... my first "serious" Delphi->Lazarus conversion

(*Thanks go to...
  https://helloacm.com/file-opening-mode-for-tfilestream-in-delphi/
  ... for a nice clear example of using TFilestream, which was a
  big help in creating this.
  And to..
  http://www.pp4s.co.uk/main/tu-oop-inbuilt-streams.html
  ... where there are other helpful examples.*)

type

  { TLDN184f1 }

  TLDN184f1 = class(TForm)
    buQuit: TButton;
    buSpecSource: TButton;
    buDest: TButton;
    buFillMeSource: TButton;
    buFillSecond: TButton;
    buSaveAltered: TButton;
    buAcceptDefaults: TButton;
    cbItIsOkayToOverW: TCheckBox;
    laExplainLock: TLabel;
    laInst2: TLabel;
    laInst1: TLabel;
    laDest: TLabel;
    laSource: TLabel;
    meSource: TMemo;
    meDest: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure buAcceptDefaultsClick(Sender: TObject);
    procedure buDestClick(Sender: TObject);
    procedure buDoLoadCopySaveClick(Sender: TObject);
    procedure buFillMeSourceClick(Sender: TObject);
    procedure buFillSecondClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buReadFrmFilestreamClick(Sender: TObject);
    procedure buSaveAlteredClick(Sender: TObject);
    procedure buSpecSourceClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbItIsOkayToOverWChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    sTmp,sTmp2,sPathNNameSource,sPathNNameDest:string;
    boSpecdSource,boSpecdDest:boolean;
    fsIncomingDataStream,fsOutgoingDataStream:TFileStream;
    bTmp:byte;
    chTmp:char;
    asTmp:AnsiString;
    procedure CopyBetweenMemos;
    function readstream( fnam: string ): string;//To go, eventually
    function readstream2( fnam: string ): string;

  public
    { public declarations }
  end; 

var
  LDN184f1: TLDN184f1;

implementation

{$R *.lfm}

{ TLDN184f1 }

procedure TLDN184f1.FormCreate(Sender: TObject);
begin
  (*Next two lines cause application to open in a "sensible" position
  regardless of the resolution the user's screen is set to.
  All of the properties referenced, e.g. screen.height, are built
  in to the ordinary Delphi environment.

  Having these two lines in the code means that the form can be
  wherever you find it most convenient on your desktop while
  developing the application*)
top:=(screen.height div 3)-(clientheight div 2);
left:=(screen.width div 2)-(clientwidth div 2);

application.title:='DD97';//Label on icon, taskbar button
caption:='DD97, version '+ver;//Title on window
laSource.caption:='(source file not yet specified)';
laDest.caption:='(destination file not yet specified)';
laExplainLock.caption:='You must specify source and destination files '+
   'before you can click "Do it".';

boSpecdSource:=false;
boSpecdDest:=false;

(*Next... configure the two memos as needed for our wants.
  One memo holds the text as it was in the source file
  The second will be filled by the application from the
  text in the first. Hence the memo's names: meSource, meDest.
Most of the memo properties can be as set by default by Delphi,
  here you see the non-default choices you need....

meSource.:=false;
meDest.:=false;
*)

meSource.WantReturns:=false;
meDest.WantReturns:=false;

meSource.wordwrap:=false;
meDest.wordwrap:=false;

meSource.scrollbars:=ssBoth;//not "necessary".. but could be useful
meDest.scrollbars:=ssBoth;

meSource.readonly:=false;
meSource.tabstop:=false;

meDest.tabstop:=false;

end;

procedure TLDN184f1.buQuitClick(Sender: TObject);
begin
  application.terminate;//"close" may be better?
end;

function TLDN184f1.readstream( fnam: string ): string;
//From http://wiki.freepascal.org/TFileStream
var
  strm: TFileStream;
  n: longint;
  txt: string;
  bTmpL:byte;//tkb added

begin
  txt := 'Could not do a read';
  //ORIG: strm := TFileStream.Create( fnam, fmOpenRead or fmShareDenyWrite );
  try //1
  strm := TFileStream.Create( fnam, fmOpenRead);
  except //1
    txt:='';
      try //2
      //n := strm.Size;
      //SetLength( txt, n );
      //strm.Read( txt[1], n );
      bTmpL:=strm.Readbyte;
      txt:=txt+chr(bTmpL);
    finally //2
      FreeAndNil(strm);
    end;//2
 end; //1
  result := txt;
end;


function TLDN184f1.readstream2( fnam: string ): string;
//Adapted from http://wiki.freepascal.org/TFileStream

//THIS WILL **fall over** if file is too big!
// (if there are more characters in it than a
//    string-type variable can hold.)
var
  strm: TFileStream;
  n: longint;
  txt: string;
  bTmpL:byte;

begin
  txt := 'rvCould not Create Stream';//Rogue value.
  try //1
     strm := TFileStream.Create( fnam, fmOpenRead or fmShareDenyWrite );
      //carry on, if no probs...
     try  //2
       txt:='';
       n := strm.Size;
       //SetLength( txt, n );
       repeat
         bTmpL:=strm.ReadByte;//( txt[1], n );
         txt:=txt+chr(bTmpL);
       until strm.Position>=n;
     finally //2
       FreeAndNil(strm);
     end;  //2
  except //1... deals with when strm could not be created
  end;//'except 1'

  result := txt;
end;

(*function readstream2( fnam: string ): string;
//From http://wiki.freepascal.org/TFileStream
//THIS COPY AS THE ROUTINE WAS BEFORE I ADAPTED IT
var
  strm: TFileStream;
  n: longint;
  txt: string;
begin
  txt := '';
  strm := TFileStream.Create( fnam, fmOpenRead or fmShareDenyWrite );
  try
    n := strm.Size;
    SetLength( txt, n );
    strm.Read( txt[1], n );
  finally
    FreeAndNil( strm );
  end;
  result := txt;
end;*)

procedure TLDN184f1.buReadFrmFilestreamClick(Sender: TObject);
begin
  meSource.clear;
  try
    fsIncomingDataStream.create('ToBeMassaged.txt',fmShareDenyWrite);
    meSource.lines.insert(0,'xx');
    meSource.lines.insert(0,'yy');//Doesn't "wreck" memo... xx moves down.

  //  fsIncomingDataStream.Read(sTmp,1);
  //  bTmp:=66;
 //   meSource.lines.insert(0,chr(bTmp));
//    meSource.lines.insert(0,chTmp);
      meSource.lines.insert(0,'FAILED first effort. Figure out why? Remove code.');

  (*except
   on E:Exception do
    meSource.lines.insert(0,'Some exception arose');

//   on E: EDatabaseError do
//    ShowMessage( 'Database error: '+ E.ClassName + #13#10 + E.Message );
    *)

  finally
  end;
  //This only "works" if it okay to close the stream even when
  //  it isn't open! "In case"!
  fsIncomingDataStream.free;
end;

(*BuSaveAlteredClick was inspired by the following, which came from...
    http://wiki.freepascal.org/TFileStream

procedure writestream( fnam: string; txt: string );
var
  strm: TFileStream;
  n: longint;
begin
  strm := TFileStream.Create( fnam, fmCreate );
  n := Length( txt );
  try
    strm.Position := 0;
    strm.Write( txt[1], n );
  finally
    FreeAndNil( strm );
  end;
end;
*)

procedure TLDN184f1.buSaveAlteredClick(Sender: TObject);
//Adapted from example at http://wiki.freepascal.org/TFileStream
//N.B.... This will not work without some improvement, if another
//  application has the output file open/ locked when this application
//  tries to write to it.
var strm: TFileStream;
    bTmpL:byte;
    liLineInMemo,liPosnInLine:longint;
    sTmpL:string;
begin
try //1
  strm := TFileStream.Create(sPathNNameDest, fmCreate );//N.B.This will overwrite any existing file
  strm.position:=0;
  liLineInMemo:=0;//Line "0" is first line in MEMO. (Note indexing
  //difference between lines in memos and characters in string)
    try //2
    repeat
      sTmpL:=meDest.lines[liLineInMemo];
      for liPosnInLine:=1 to length(sTmpL) do begin //For...
          bTmpL:=ord(sTmpL[liPosnInLine]);//sTmpL[1] is 1st char in string.
          strm.WriteByte(bTmpL);
          end;//For...
      inc(liLineInMemo);
      strm.WriteByte(13);//Insert CR in output
      strm.WriteByte(10);//Insert LF in output
    until liLineInMemo=meDest.Lines.count;
  except//2
    on e:Exception do showmessage('problem... 17a21a');
  end;//e
except //1
  on e:Exception do showmessage('problem... 17a21b');
end;//try "1"
  FreeAndNil(strm);
end;

procedure TLDN184f1.buDestClick(Sender: TObject);
(*There are all sorts of things you can do to "tailor"
users' experiences with the SaveDialog. For instance,
you can set things up to warn users if they are
starting down a course of action which will
cause an existing file to be overwritten.
Those "frills" I am leaving to another time.*)
begin
if SaveDialog1.execute then begin
   sPathNNameDest:=SaveDialog1.filename;
   laDest.caption:=sPathNNameDest;
   boSpecdDest:=true;
   end;
buAcceptDefaultsClick(self);
end;

procedure TLDN184f1.buAcceptDefaultsClick(Sender: TObject);
//This handler ALSO called whenever source or dest spec called.
var boTmpL:boolean;
begin
boTmpL:=true;
  if not fileexists(sPathNNameSource) then begin
     boTmpL:=false;
     laSource.caption:='<default filename did not match any existing file>';
     end;//sPath..source did NOT exist

  if (fileexists(sPathNNameDest)) and
     (cbItIsOkayToOverW.checked=false) then begin
        boTmpL:=false;
        laDest.caption:='<default filename is an existing file, and you forbid over-writing>';
        end;//sPath..dest DID exist

  if boTmpL then begin
      buFillMeSource.enabled:=true;
      buFillSecond.enabled:=true;
      buSaveAltered.enabled:=true;
      end//no ; here
    else begin //In case user "goes back" after setting source or dest...
      buFillMeSource.enabled:=false;
      buFillSecond.enabled:=false;
      buSaveAltered.enabled:=false;
    end;
end;

procedure TLDN184f1.buDoLoadCopySaveClick(Sender: TObject);
begin
meSource.lines.loadfromfile(sPathNNameSource);
CopyBetweenMemos;
meDest.lines.savetofile(sPathNNameDest);
end;

procedure TLDN184f1.buFillMeSourceClick(Sender: TObject);
var sTmpL,sFileToReadL:string;
//There are far simple ways to move a file to a memo!!
//This is "doing it by hand", with a TFileStream to ILLUSTRATE
//  USE OF TFileStream!
begin
sFileToReadL:=sPathNNameSource;
sTmpL:='file did not exist';//Shouldn't arise... but doesn't
   //cost much to double check!
if fileexists(sFileToReadL) then begin //1
  meSource.lines.insert(0,'found it');
  sTmpL:=readstream2(sFileToReadL);
  end;//1
meSource.lines.clear;
meSource.lines.insert(0,sTmpL);
end;

procedure TLDN184f1.buFillSecondClick(Sender: TObject);
begin
  CopyBetweenMemos;
end;


procedure TLDN184f1.buSpecSourceClick(Sender: TObject);
(*There are all sorts of things you can do to "tailor"
users' experiences with the OpenDialog. For instance,
you can set the filter to show only files with the
extension or extensions you want them to see.
Those "frills" I am leaving to another time.*)
begin
if OpenDialog1.execute then begin
   sPathNNameSource:=OpenDialog1.filename;
   laSource.caption:=sPathNNameSource;
   boSpecdSource:=true;
   end;
buAcceptDefaultsClick(self);
end;

procedure TLDN184f1.Button1Click(Sender: TObject);
var sTmpL,sFileToReadL:string;
begin
sFileToReadL:=sPathNNameSource;
sTmpL:='file did not exist';//Shouldn't arise... but doesn't
   //cost much to double check!
if fileexists(sFileToReadL) then begin //1
  meSource.lines.insert(0,'found it');
  sTmpL:=readstream2(sFileToReadL);
  end;//1
meSource.lines.insert(0,sTmpL);
end;

procedure TLDN184f1.cbItIsOkayToOverWChange(Sender: TObject);
begin
 buAcceptDefaultsClick(self);
 laDest.caption:=sPathNNameDest;
end;

procedure TLDN184f1.FormActivate(Sender: TObject);
begin
  sPathNNameSource:='ToBeMassaged.txt';
  laSource.caption:=sPathNNameSource;

  sPathNNameDest:='Tmp.txt';
  laDest.caption:=sPathNNameDest;

  buFillMeSource.enabled:=false;
  buFillSecond.enabled:=false;
  buSaveAltered.enabled:=false;

  meSource.lines.clear;
  meSource.lines.insert(0,'First memo');

  meDest.lines.clear;
  meDest.lines.insert(0,'Second memo');
end;

procedure TLDN184f1.CopyBetweenMemos;
(*This is the "heart" of the program, in terms of
it doing something useful.

For this tutorial, all it is doing is copying the
text from the source file to the destination.

For a simple copy, all that would be needed is...

meDest.clear;//clear it; prepare for filling
for wWhatLine:=0 to meSource.lines.count-1 do begin
   sTmp:=meSource.lines[wWhatLine];
   meDest.lines.add(sTmp);
   end;//for loop

... however that would be REALLY pointless, so for
the sake of the tutorial, we will dress it up a
little and make the following "just for demonstration"
changes to the text as it is copied. We will be...

1) substituting 'X' each time an 'n' is encountered, and
2) dropping all 'a's out of the text.

... which is a pointless exercise. But I hope it
shows you the basics of whatever transformation
you want to make to your files? In all of the above,
I was speaking in case sensitive terms.

No check, by the way, is made to see that the file
only holds printable characters.

In some ways, that won't matter, but you'll have
trouble looking at the file with some text
editors if the characters in the file include
non-printing characters.
*)
var wWhatLine,c1:word;

begin
meDest.clear;//clear it; prepare for filling
for wWhatLine:=0 to meSource.lines.count-1 do begin
   sTmp:=meSource.lines[wWhatLine];
   sTmp2:='';
   for c1:=1 to length(sTmp) do begin
       if sTmp[c1]='n' then sTmp2:=sTmp2+'X';
       if (sTmp[c1]<>'a') and (sTmp[c1]<>'n') then sTmp2:=sTmp2+sTmp[c1];
       (*if sTmp[c1]='a' then do nothing*)
       end;//for c1 loop
   meDest.lines.add(sTmp2);
   end;//for wWhatLine loop
end;

end.

